﻿using System;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.IO.Ports;
using System.Text.RegularExpressions;
using AutoProgramer.Data;

namespace AutoProgramer
{
	/// <summary>
	/// MainWindow.xaml の相互作用ロジック
	/// </summary>
	public partial class MainWindow : Window
	{
		public SerialPort Serial { get; set; }
		public HexData _HexData { get; set; }

		public MainWindow()
		{
			InitializeComponent();
			Button_Click_3(null, null);

		}

		/// <summary>
		/// Press Open Button
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Button_Click(object sender, RoutedEventArgs e)
		{
			if (null == combo.SelectedItem) return;
			if (null == Serial) Serial = new SerialPort((string)combo.SelectedItem, 115200, Parity.None, 8, StopBits.One);
			if (false == Serial?.IsOpen) Serial.Open();
			Serial.Disposed += Serial_Disposed;
			TextBox_Status.Text = "OPEN";
			textBlock_Comname.Text = Serial.PortName;
		}

		private void Serial_Disposed(object sender, EventArgs e)
		{
			TextBox_Status.Text = "CLOSE";
			textBlock_Comname.Text = "";
		}

		/// <summary>
		/// Press Write Button
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Button_Click_1(object sender, RoutedEventArgs e)
		{
			if (null == Serial | false == Serial.IsOpen) return;
			//HexData hex = CreateSerialText(text.Text);
			//string[] wsrts = $@"{_HexData.addr.ToString("X")}N{_HexData.Hex}".Split(,);
			string wStr = $@"{_HexData.addr.ToString("X")}N{_HexData.Hex}";
            //int cnt = 0;
            //int cc = 25;
            int delayTime = int.TryParse(textBox_delay.Text, out delayTime) ? delayTime : 40;
			Task.Run(() =>
			{
				foreach (char wchr in wStr)
				{
					Serial.Write($"{wchr}");
					System.Threading.Thread.Sleep(delayTime);
					//Serial.Write($",");
					//System.Threading.Thread.Sleep(20);
					/*if(cnt >= cc)
					{
						System.Threading.Thread.Sleep(500);
						cc += 50;
					}
					cnt++;*/
					Console.WriteLine($"{wchr}");
				}
			});
		}
		/// <summary>
		/// Press Close Button 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Button_Click_2(object sender, RoutedEventArgs e)
		{
			if (null == Serial | false == Serial.IsOpen) return;
			Serial.Dispose();

		}

		/// <summary>
		/// Generate Write Text and Start Adress From Hex File Format
		/// </summary>
		/// <param name="hexStr"></param>
		/// <returns></returns>
		public HexData CreateSerialText(string hexStr)
		{
			var HexData = new HexData();

            var addrs = new Regex(@"\(\d*\)", RegexOptions.IgnoreCase);
            var addrmatch = addrs.Matches(hexStr);
            if (addrmatch.Count == 0) return HexData;
            foreach(var match in addrmatch)
            {
                hexStr = hexStr.Replace(match.ToString(), "");
            }
            string str = addrmatch[0].Value.ToString();
            str = str.Substring(1, str.Length - 2);
            int addr = int.TryParse(str,System.Globalization.NumberStyles.HexNumber,null,out addr)? addr : 0 ;
            HexData.addr = addr;
           
            var retStr = new StringBuilder();
            var regex = new Regex(@"\w{2}", RegexOptions.IgnoreCase);
            var matches = regex.Matches(hexStr);
            retStr.Clear();
            int cnt = 0;

            foreach (Match match in matches)
            {
                retStr.Append(match.Value + ",");
                //Console.WriteLine(match.Value);
                cnt++;
            }
            HexData.Hex = retStr.ToString();
            HexData.finaddr = addr + cnt;
            retStr.Clear();
            return HexData;
            /*
			var retStr = new StringBuilder();

			var regex = new Regex(@":.*", RegexOptions.IgnoreCase);
			MatchCollection matches = regex.Matches(hexStr);
			if (0 == matches.Count) return new HexData();
			int addr = int.TryParse(matches[0].Value.Substring(3, 4), System.Globalization.NumberStyles.HexNumber, null, out addr) ? addr : 0;
			HexData.addr = addr;

			foreach (Match match in matches)
			{
				if (11 >= match.Value.Length) break;
				retStr.Append(match.Value.Substring(9, match.Value.Length - 11));
				Console.WriteLine(retStr);
				match.NextMatch();
			}

			regex = new Regex(@".{2}", RegexOptions.IgnoreCase);
			matches = regex.Matches(retStr.ToString());
			retStr.Clear();
			int cnt = 0;

			foreach (Match match in matches)
			{
				retStr.Append(match.Value + ",");
				cnt++;
			}

			Console.WriteLine(retStr.ToString());
			HexData.Hex = retStr.ToString();
			HexData.finaddr = addr + cnt;
			retStr = null;
            */
            //return HexData;
		}


		/// <summary>
		/// when HexTextChanged It Calculate Start Adress 
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void Text_TextChanged(object sender, TextChangedEventArgs e)
		{
			string texts = text.Text;
			Task.Run(() =>
			{
				_HexData = CreateSerialText(texts);
				TextBlock_StAdress.Dispatcher.Invoke(() => { TextBlock_StAdress.Text = $"0x{_HexData.addr.ToString("X")}"; });
				TextBlock_FinAddress.Dispatcher.Invoke(() => { TextBlock_FinAddress.Text = $"0x{_HexData.finaddr.ToString("X")}"; });
			});
		}

		private void Button_Click_3(object sender, RoutedEventArgs e)
		{
			combo.Items.Clear();
			foreach (var port in SerialPort.GetPortNames()) combo.Items.Add(port);
		}
	}
}
